package gui.util.logpanel;

/*	This program is released under European Union Public License.
 *  for details please refer to the file LICENSE
 *   
 *  Disclaimer: the program comes "as is" and with absolutely no warranty 
 *  
 *  © 2010 TCM
 */

import gui.util.GuiUtil;

import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;

public class LogPanel extends JScrollPane{
	private static final long serialVersionUID = 1L;

	private JScrollBar vbar;
	
	private boolean autoScrollLog;
	
	private JList<String> logList;
	private DefaultListModel<String> logListModel;
	
	public LogPanel() {
		super();
		
		logListModel=new DefaultListModel<>();
		logList=new JList<>(logListModel);
		
		logList.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		
		setViewportView(logList);
		
		autoScrollLog=true;
		
		vbar=getVerticalScrollBar();
		vbar.setValues(0, 0, 0, 0);
		
//		vbar.addAdjustmentListener(new AdjustmentListener() {  
//			public void adjustmentValueChanged(AdjustmentEvent e) {  
//				if (autoScrollLog) {
//					e.getAdjustable().setValue(e.getAdjustable().getMaximum());
//				}
//			 }
//		}); 
		
		vbar.addMouseListener(new MouseListener() {
			
			@Override
			public void mouseReleased(MouseEvent e) {
				autoScrollLog=true;
			}
			
			@Override
			public void mousePressed(MouseEvent e) {
				autoScrollLog=false;
			}
			
			@Override
			public void mouseExited(MouseEvent e) {}
			
			@Override
			public void mouseEntered(MouseEvent e) {}
			
			@Override
			public void mouseClicked(MouseEvent e) {}
		});
		
		setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		
		
	}

	public void clear() {
		synchronized (logList.getTreeLock()) {
			logListModel.clear();
		}
	}
	
	public void addToLog(String s) {
		synchronized (logList.getTreeLock()) {
			logListModel.addElement(GuiUtil.formatTime(System.currentTimeMillis())+": "+ s);
			if (autoScrollLog)
				logList.ensureIndexIsVisible(logListModel.getSize()-1);
		} 
		
	}
}
