package io.downloaders;
/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */



import io.downloaders.Downloader;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

import net.util.LinkExtractorByHtmlElement;

import shoshone.httpclient.ShoshoneClient;
import util.StringUtil;
import util.exception.CancelException;
import model.DLInfo;
import model.transfer.EngineConfig;

public class MinDotUsDownloader extends Downloader {
	private ShoshoneClient sc;
	
	public MinDotUsDownloader(DLInfo info, EngineConfig cfg) throws IOException {
		super(info, cfg);
		sc=new ShoshoneClient(null,true);
	}

	@Override
	public void updateCurrentBytes() {
		dlInfo.updateBytes(sc.getTransferedBytes());
	}

	@Override
	public void startTransfer() throws IOException, CancelException {
		String url=dlInfo.getUrl();
		sc.setProxy(proxy);
		sc.setUrl(url);
		sc.setAutoReferer();
		sc.setFollowRedirects(true);
		
		sc.applyGetRequest();
		
		String html=sc.getResponse();
		String l=LinkExtractorByHtmlElement.getLinkExtractor().getLink(url, html, new String[]{"rel","image_src","href"});
		//String l2= LinkExtractorById.getLinkExtractor().getLink(url, html, new String[]{"link_canonical","href"});
		int i=html.indexOf("\"items\":");
		int k=html.indexOf("\"name\":",i);
		int start=html.indexOf('"',k)+9;
		int end=html.indexOf('"',start);
		String fn=html.substring(start,end);
		String ext=fn.substring(fn.lastIndexOf('.'));
		
		String rd = StringUtil.replaceFirst(StringUtil.replaceFirst(l,"_xs.jpg", ext),"/j", "/d");
		sc.setUrl(rd);
		sc.applyGetRequest(false);
		if (sc.getContentLength()!=-1) dlInfo.setFileSize(sc.getContentLength());
		if (dlInfo.getFileName()==null)	dlInfo.setFileName(sc.getFilename());
		
		createOutDirs();
		Path f=dlInfo.getOutputFile();
		sc.readResponseAndSave(f);
		sc.closeConnection();
		
		if (dlInfo.getFileSize()==-1) dlInfo.setFileSize(Files.size(f));
		
	}

	@Override
	public void cancel() {
		if (sc!=null) sc.cancel();		
	}

}
